VERSION 5.00
Begin VB.Form frmTooltip 
   AutoRedraw      =   -1  'True
   BackColor       =   &H80000018&
   BorderStyle     =   3  'Fixed Dialog
   ClientHeight    =   1095
   ClientLeft      =   45
   ClientTop       =   45
   ClientWidth     =   3960
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   73
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   264
   ShowInTaskbar   =   0   'False
   Begin VB.Timer tmrOut 
      Interval        =   100
      Left            =   45
      Top             =   630
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      BackColor       =   &H80000018&
      BackStyle       =   0  'Transparent
      Caption         =   "lblCaption"
      Height          =   195
      Left            =   90
      TabIndex        =   0
      Top             =   90
      Width           =   3750
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "frmTooltip"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type RECT
    left As Long
    top As Long
    right As Long
    bottom As Long
End Type
Private Type POINTAPI
    X As Long
    Y As Long
End Type

'pour <frmTooltip> pour son affichage
'*************************************
Private Declare Function GetForegroundWindow Lib "user32.dll" () As Long
Private Declare Function GetWindowRect Lib "user32.dll" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function GetWindowPlacement Lib "user32.dll" (ByVal hwnd As Long, lpwndpl As WINDOWPLACEMENT) As Long

Private Declare Function GetClassLong Lib "user32.dll" Alias "GetClassLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetClassLong Lib "user32.dll" Alias "SetClassLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Private Const CS_DROPSHADOW = &H20000
Private Const GCL_STYLE = -(26)
    
Private Type WINDOWPLACEMENT
        Length As Long
        flags As Long
        showCmd As Long
        ptMinPosition As POINTAPI
        ptMaxPosition As POINTAPI
        rcNormalPosition As RECT
End Type
'*************************************

Private hPWnd As Long 'handle du controle parent

Public Property Get hParentWnd() As Long
    hParentWnd = hPWnd
End Property
Public Property Let hParentWnd(ByVal hwnd As Long)
    Dim lpRect As RECT
    
    hPWnd = hwnd
    'on change la position de la fenetre
    Call GetWindowRect(hPWnd, lpRect)
    Me.left = lpRect.left * Screen.TwipsPerPixelX
    Me.top = lpRect.bottom * Screen.TwipsPerPixelY
End Property

Public Property Get Text() As String
    Text = lblCaption.Caption
End Property
Public Property Let Text(ByVal sText As String)
    lblCaption.Caption = sText
End Property

Public Function ShowMe(Optional Modal As Long = 0, Optional OwnerForm As Form = Nothing)
    Call Me.Show(Modal, OwnerForm)
    Call SetClassLong(Me.hwnd, GCL_STYLE, GetClassLong(Me.hwnd, GCL_STYLE) Or CS_DROPSHADOW)
End Function

Private Sub Form_Resize()
    If (Me.left + Me.Width > Screen.Width) Then
        Me.left = Screen.Width - Me.Width
    End If
    
    If (Me.top + Me.Height > Screen.Height) Then
        Me.top = Screen.Height - Me.Height
    End If
End Sub

Private Sub lblCaption_Change()
    Me.Width = (lblCaption.left * 2 + lblCaption.Width) * Screen.TwipsPerPixelX + (Me.Width - Me.ScaleWidth * Screen.TwipsPerPixelX)
    Me.Height = (lblCaption.top * 2 + lblCaption.Height) * Screen.TwipsPerPixelY + (Me.Height - Me.ScaleHeight * Screen.TwipsPerPixelY)
End Sub

Private Sub lblCaption_Click()
    Call Unload(Me)
End Sub

Private Sub tmrOut_Timer()
    If (GetForegroundWindow <> Me.hwnd) Then Call Unload(Me)
End Sub
