VERSION 5.00
Begin VB.UserControl ctlHyperlink 
   BackColor       =   &H00FFFFFF&
   CanGetFocus     =   0   'False
   ClientHeight    =   300
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2715
   MaskColor       =   &H00FF00FF&
   ScaleHeight     =   300
   ScaleWidth      =   2715
   Begin VB.Timer tmrMouseOut 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   2295
      Top             =   0
   End
   Begin VB.Label lblText 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "lblText"
      Height          =   195
      Left            =   45
      MousePointer    =   99  'Custom
      TabIndex        =   0
      Top             =   45
      Width           =   465
   End
End
Attribute VB_Name = "ctlHyperlink"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Type RECT
    left As Long
    top As Long
    right As Long
    bottom As Long
End Type

Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hwnd As Long, ByVal hDC As Long) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function GetWindowDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetDCEx Lib "user32" (ByVal hwnd As Long, ByVal hrgnclip As Long, ByVal fdwOptions As Long) As Long
Private Declare Function WindowFromDC Lib "user32" (ByVal hDC As Long) As Long

Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Const SRCAND = &H8800C6  ' (DWORD) dest = source AND dest
Private Const SRCCOPY = &HCC0020 ' (DWORD) dest = source
Private Const SRCERASE = &H440328        ' (DWORD) dest = source AND (NOT dest )
Private Const SRCINVERT = &H660046       ' (DWORD) dest = source XOR dest
Private Const SRCPAINT = &HEE0086        ' (DWORD) dest = source OR dest

Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Private Declare Function GetCursorPos Lib "user32" (ByRef lpPoint As POINTAPI) As Long
Private Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long

Private Declare Function ShellExecuteA Lib "shell32.dll" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Const SW_NORMAL As Long = &H1

Public Enum lnkAlignment
    AlignLeft = 0
    AlignRight = 1
    AlignCenter = 2
End Enum

'Valeurs par dfaut !
Private Const cCaption = "HyperLink"
Private Const cTarget = vbNullString
Private Const cForeColor = vbButtonText
Private Const cOnForeColor = vbInactiveTitleBar
Private Const cBackColor = &HFF00FF
Private Const cEnabled = True
Private Const cMoveUnderline = False
Private Const cAutoSize = True
Private Const cWordWrap = False
Private Const cActiveDownColor = False
Private Const cAlignment = AlignLeft

'Proprits :
Private myForeColor As OLE_COLOR 'ForeColor
Private myBackColor As OLE_COLOR 'BackColor
Private myDownForeColor As OLE_COLOR 'DownForeColor
Private myOnForeColor As OLE_COLOR 'OnForeColor
Private myCaption As String 'Caption
Private myFont As Font 'Font
Private myTarget As String 'Target
Private myEnabled As Boolean 'Enabled
Private myMoveUnderline As Boolean 'Enabled
Private myAutoSize As Boolean 'AutoSize
Private myWordWrap As Boolean 'WordWrap
Private myActiveDownColor As Boolean 'ActiveDownColor
Private myAlignment As lnkAlignment 'Alignment

'Evnements :
Public Event Click(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event Change()
Public Event DblClick()
Public Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseOut()
Public Event Resize()
Public Event Show()
Public Event Terminate()
Public Event Paint(ByRef hDC As Long)

'Proprits
'-------------------------------------------------------------------------------------
Public Property Get hwnd() As Long
    Let hwnd = UserControl.hwnd
End Property

Public Property Get hDC() As Long
    Let hDC = UserControl.hDC
End Property

Public Property Get ActiveDownColor() As Boolean
    Let ActiveDownColor = myActiveDownColor
End Property

Public Property Let ActiveDownColor(ByVal Value As Boolean)
    Let myActiveDownColor = Value
    Call PropertyChanged("ActiveDownColor")
    Call Refresh
End Property

Public Property Get Alignment() As lnkAlignment
    Let Alignment = myAlignment
End Property

Public Property Let Alignment(ByVal Value As lnkAlignment)
    Let myAlignment = Value
    Call PropertyChanged("Alignment")
    Call Refresh
End Property

Public Property Get AutoSize() As Boolean
    Let AutoSize = myAutoSize
End Property

Public Property Let AutoSize(ByVal Value As Boolean)
    Let myAutoSize = Value
    Call PropertyChanged("AutoSize")
    Call Refresh
End Property

Public Property Get WordWrap() As Boolean
    Let WordWrap = myWordWrap
End Property

Public Property Let WordWrap(ByVal Value As Boolean)
    Let myWordWrap = Value
    Call PropertyChanged("WordWrap")
    Call Refresh
End Property

Public Property Get MoveUnderline() As Boolean
    Let MoveUnderline = myMoveUnderline
End Property

Public Property Let MoveUnderline(ByVal Value As Boolean)
    Let myMoveUnderline = Value
    Call PropertyChanged("MoveUnderline")
    Call Refresh
End Property

Public Property Get Enabled() As Boolean
    Let Enabled = myEnabled
End Property

Public Property Let Enabled(ByVal Value As Boolean)
    Let myEnabled = Value
    Call PropertyChanged("Enabled")
    Call Refresh
End Property

Public Property Get Caption() As String
    Let Caption = myCaption
End Property

Public Property Let Caption(ByVal Value As String)
    Let myCaption = Value
    Call PropertyChanged("Caption")
    Call Refresh
End Property

Public Property Get Font() As Font
    Set Font = myFont
End Property

Public Property Set Font(ByVal Value As Font)
    Set myFont = Value
    Call PropertyChanged("Font")
    Call Refresh
End Property

Public Property Get ForeColor() As OLE_COLOR
    Let ForeColor = myForeColor
End Property

Public Property Let ForeColor(ByVal Value As OLE_COLOR)
    Let myForeColor = Value
    Call PropertyChanged("ForeColor")
    Call Refresh
End Property

Public Property Get BackColor() As OLE_COLOR
    Let BackColor = myBackColor
End Property

Public Property Let BackColor(ByVal Value As OLE_COLOR)
    Let myBackColor = Value
    Call PropertyChanged("BackColor")
    Call Refresh
End Property

Public Property Get OnForeColor() As OLE_COLOR
    Let OnForeColor = myOnForeColor
End Property

Public Property Let OnForeColor(ByVal Value As OLE_COLOR)
    Let myOnForeColor = Value
    Call PropertyChanged("OnForeColor")
    Call Refresh
End Property

Public Property Get DownForeColor() As OLE_COLOR
    Let DownForeColor = myDownForeColor
End Property

Public Property Let DownForeColor(ByVal Value As OLE_COLOR)
    Let myDownForeColor = Value
    Call PropertyChanged("DownForeColor")
    Call Refresh
End Property

Public Property Get Target() As String
    Let Target = myTarget
End Property

Public Property Let Target(ByVal Value As String)
    Let myTarget = Value
    Call PropertyChanged("Target")
    Call Refresh
End Property
'-------------------------------------------------------------------------------------

Private Sub lbltext_Change()
On Error Resume Next
    Call Refresh
    RaiseEvent Change
End Sub

Private Sub lbltext_DblClick()
On Error Resume Next
    Call Refresh
    RaiseEvent DblClick
End Sub

Private Sub lbltext_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
On Error Resume Next
    If (Button = 1 And Shift = 0 And myActiveDownColor = True) Then Let lblText.ForeColor = myDownForeColor
    
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub lbltext_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
On Error Resume Next
    If (Button = 0 And Shift = 0) Then
        If (lblText.ForeColor <> myBackColor) Then Let lblText.ForeColor = myOnForeColor
        If (myMoveUnderline = True And lblText.Font.Underline = False) Then Let lblText.Font.Underline = True
    End If
    
    
    Let tmrMouseOut.Enabled = True
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub lbltext_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
On Error Resume Next
    Call Refresh
    If (myFont.Underline = False) Then Let lblText.Font.Underline = False
    DoEvents
    
    If (Button = 1 And Shift = 0 And (X >= 0 And Y >= 0) And (X <= UserControl.Width And Y <= UserControl.Height) And myTarget <> vbNullString) Then Call ShellExecuteA(UserControl.hwnd, "open", myTarget, vbNullString, vbNullString, SW_NORMAL)
    If (Button = 1 And Shift = 0 And (X >= 0 And Y >= 0) And (X <= UserControl.Width And Y <= UserControl.Height)) Then RaiseEvent Click(Button, Shift, X, Y)
    
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

Private Sub tmrMouseOut_Timer()
On Error Resume Next
    If (IsUnderMouse(UserControl.hwnd) = False) Then: Call Refresh: Let tmrMouseOut.Enabled = False: RaiseEvent MouseOut
End Sub

Private Sub UserControl_InitProperties()
On Error Resume Next

    Let myCaption = cCaption
    Set myFont = Ambient.Font
    Let myTarget = cTarget
    Let myBackColor = cBackColor
    Let myForeColor = cForeColor
    Let myOnForeColor = cOnForeColor
    Let myBackColor = cBackColor
    Let myEnabled = cEnabled
    Let myDownForeColor = myBackColor
    Let myMoveUnderline = cMoveUnderline
    Let myAutoSize = cAutoSize
    Let myWordWrap = cWordWrap
    Let myActiveDownColor = cActiveDownColor
    Let myAlignment = cAlignment
    
    Call Refresh
End Sub

Private Sub UserControl_Paint()
On Error Resume Next
    Dim hDeviceContext As Long
    Dim X As Long
    Dim Y As Long
    Dim lpRect As RECT
    Dim lpRect2 As RECT
    
    If (myBackColor = &HFF00FF) Then
        Let hDeviceContext = GetDC(ByVal UserControl.ContainerHwnd)
        RaiseEvent Paint(hDeviceContext)
        Call GetWindowRect(ByVal UserControl.hwnd, lpRect)
        Call GetWindowRect(ByVal UserControl.ContainerHwnd, lpRect2)
        
        Call BitBlt(ByVal UserControl.hDC, ByVal 0, ByVal 0, ByVal UserControl.ScaleWidth / Screen.TwipsPerPixelX, ByVal UserControl.ScaleHeight / Screen.TwipsPerPixelY, ByVal hDeviceContext, ByVal lpRect.left - lpRect2.left, ByVal lpRect.top - lpRect2.top, ByVal SRCCOPY)
    Else
        UserControl.BackColor = myBackColor
    End If
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
On Error Resume Next

    Let myCaption = PropBag.ReadProperty("Caption", cCaption)
    Set myFont = PropBag.ReadProperty("Font", Ambient.Font)
    Let myTarget = PropBag.ReadProperty("Target", cTarget)
    Let myBackColor = PropBag.ReadProperty("BackColor", cBackColor)
    Let myBackColor = PropBag.ReadProperty("BackColor", cBackColor)
    Let myDownForeColor = PropBag.ReadProperty("DownForeColor", myBackColor)
    Let myForeColor = PropBag.ReadProperty("ForeColor", cForeColor)
    Let myOnForeColor = PropBag.ReadProperty("OnForeColor", cOnForeColor)
    Let myEnabled = PropBag.ReadProperty("Enabled", cEnabled)
    Let myMoveUnderline = PropBag.ReadProperty("MoveUnderline", cMoveUnderline)
    Let myAutoSize = PropBag.ReadProperty("AutoSize", cAutoSize)
    Let myWordWrap = PropBag.ReadProperty("WordWrap", cWordWrap)
    Let myActiveDownColor = PropBag.ReadProperty("ActiveDownColor", cActiveDownColor)
    Let myAlignment = PropBag.ReadProperty("Alignment", cAlignment)
    
    Call Refresh
End Sub

Private Sub UserControl_Resize()
On Error Resume Next

    Let lblText.left = 0 'Screen.TwipsPerPixelX * 5
    Let lblText.top = 0
    
    If (myAutoSize = True) Then
        
        If (myWordWrap = False) Then
            Let UserControl.Width = lblText.Width + lblText.left * 2
        End If
        
        Let lblText.AutoSize = False: lblText.AutoSize = True
        Let UserControl.Height = lblText.Height + lblText.top * 2
    
    Else
        Let lblText.Width = UserControl.Width
        Let lblText.Height = UserControl.Height
    End If
    
End Sub

Private Sub UserControl_Show()
On Error Resume Next
    lblText.MousePointer = vbDefault
    
    RaiseEvent Show
    Call Refresh
End Sub

Private Sub UserControl_Terminate()
On Error Resume Next
    RaiseEvent Terminate
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
On Error Resume Next
    
    Call PropBag.WriteProperty("Target", myTarget, cTarget)
    Call PropBag.WriteProperty("Caption", myCaption, cCaption)
    Call PropBag.WriteProperty("Font", myFont, Ambient.Font)
    Call PropBag.WriteProperty("BackColor", myBackColor, cBackColor)
    Call PropBag.WriteProperty("DownForeColor", myDownForeColor, myBackColor)
    Call PropBag.WriteProperty("ForeColor", myForeColor, cForeColor)
    Call PropBag.WriteProperty("OnForeColor", myOnForeColor, cOnForeColor)
    Call PropBag.WriteProperty("Enabled", myEnabled, cEnabled)
    Call PropBag.WriteProperty("MoveUnderline", myMoveUnderline, cMoveUnderline)
    Call PropBag.WriteProperty("AutoSize", myAutoSize, cAutoSize)
    Call PropBag.WriteProperty("WordWrap", myWordWrap, cWordWrap)
    Call PropBag.WriteProperty("ActiveDownColor", myActiveDownColor, cActiveDownColor)
    Call PropBag.WriteProperty("Alignment", myAlignment, cAlignment)
    Call PropBag.WriteProperty("BackColor", myBackColor, cBackColor)
    
    Call Refresh
End Sub

Public Sub Refresh()
On Error Resume Next
    
    Let lblText.ForeColor = myForeColor
    
    Set lblText.Font = myFont
    Let lblText.Caption = myCaption
    Let lblText.Enabled = myEnabled
    Let lblText.AutoSize = Not myAutoSize: Let lblText.AutoSize = myAutoSize
    Let lblText.WordWrap = myWordWrap
    Let lblText.Alignment = myAlignment
    
    If (myMoveUnderline = True) Then Let lblText.Font.Underline = False
    
    Call UserControl_Resize
    Call UserControl_Paint
End Sub

'Check to see if the control is under the cursor
Private Function IsUnderMouse(ByVal MyhWnd As Long) As Boolean
On Error Resume Next
    Dim ptMouse As POINTAPI

    Call GetCursorPos(ptMouse)
    If (WindowFromPoint(ByVal ptMouse.X, ByVal ptMouse.Y) = MyhWnd) Then
      Let IsUnderMouse = True
    Else
      Let IsUnderMouse = False
    End If
  
End Function
